﻿Imports GrapeCity.Windows.SpreadSheet.Data

Class MainWindow
    Private r As Integer = 3
    Private c As Integer = 1
    Private w As Integer = 10
    Private h As Integer = 8
    Private Sub Window_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        textBlock1.TextWrapping = TextWrapping.Wrap
        textBlock1.Text = "Select any conditional format rule from drop down."
        Dim cbstr As String()
        cbstr = New [String]() {"No Conditional Formatting Rule", "Iconset Rule", "DataBar Rule", "CellValue Rule", "Average Rule", "Duplicate Rule"}
        comboBox1.SelectedItem = "No Conditional Formatting Rule"
        comboBox1.ItemsSource = cbstr
        Dim sheet As Worksheet = gcSpreadSheet1.ActiveSheet
        Dim increase = 0
        For row As Integer = 0 To h - 2
            For col As Integer = 0 To w - 1
                sheet.SetValue(row + r + 1, col + c, increase)
                increase += 10
            Next
        Next
        sheet.SetBorder(New CellRange(r, c, h, w), New BorderLine(Colors.Black, BorderLineStyle.Dashed), SetBorderOptions.All)
    End Sub
    Private Sub comboBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles comboBox1.SelectionChanged
        Dim sheet As Worksheet = gcSpreadSheet1.ActiveSheet
        Dim combo = TryCast(sender, ComboBox)
        Dim val As String = DirectCast(combo.SelectedItem, [String])
        If val = "Iconset Rule" Then
            textBlock1.Text = "Five arrows are shown in cell to format the value with different color."
            sheet.ConditionalFormats.ClearRule()
            sheet.ConditionalFormats.AddIconSetRule(IconSetType.FiveArrowsColored, New CellRange(r + 1, c, h - 1, w))
        End If

        If val = "DataBar Rule" Then
            textBlock1.Text = "Data bars are shown in each cell with maximum data limit set to 700."
            sheet.ConditionalFormats.ClearRule()
            sheet.ConditionalFormats.AddDataBarRule(ScaleValueType.Number, 0, ScaleValueType.Number, 700, Colors.Brown, New CellRange(r, c, h, w))
        End If

        If val = "CellValue Rule" Then
            textBlock1.Text = "All cells with value more than 300 and less than 500 are formatted with lightGray back color and Red fore color."
            sheet.ConditionalFormats.ClearRule()
            Dim myValueStyle As GrapeCity.Windows.SpreadSheet.Data.StyleInfo = New StyleInfo()
            myValueStyle.Background = New SolidColorBrush(Colors.LightGray)
            myValueStyle.Foreground = New SolidColorBrush(Colors.Red)
            sheet.ConditionalFormats.AddCellValueRule(ComparisonOperator.Between, 300, 500, myValueStyle, New CellRange(r, c, h, w))
        End If

        If val = "Average Rule" Then
            textBlock1.Text = "All cells with value less than the average of this group of cells are formatted with Green back color and yellow as forecolor."
            sheet.ConditionalFormats.ClearRule()
            Dim myAverageStyle As GrapeCity.Windows.SpreadSheet.Data.StyleInfo = New StyleInfo()
            myAverageStyle.Background = New SolidColorBrush(Colors.Green)
            myAverageStyle.Foreground = New SolidColorBrush(Colors.Yellow)
            sheet.ConditionalFormats.AddAverageRule(AverageConditionType.Below, myAverageStyle, New CellRange(r, c, h, w))
        End If

        If val = "Duplicate Rule" Then
            textBlock1.Text = "It finds duplicate values with in a given range of cells and apply style with making the font bold and highlighting with White forecolor."
            sheet.ConditionalFormats.ClearRule()
            Dim myDuplicateStyle As GrapeCity.Windows.SpreadSheet.Data.StyleInfo = New StyleInfo()
            myDuplicateStyle.Background = New SolidColorBrush(Colors.Red)
            myDuplicateStyle.Foreground = New SolidColorBrush(Colors.White)
            myDuplicateStyle.FontWeight = FontWeights.Bold
            sheet.ConditionalFormats.AddDuplicateRule(myDuplicateStyle, New CellRange(r, c, h, w))
        End If

        If val = "No Conditional Formatting Rule" Then
            textBlock1.Text = "No conditional formatting rule is applied to cells"
            sheet.ConditionalFormats.ClearRule()
        End If
    End Sub
End Class
